"use strict";exports.__esModule = true;exports.___setTaglibLookup = ___setTaglibLookup;exports.getTaglibLookup = getTaglibLookup;exports.getTagDefForTagName = getTagDefForTagName;const LOOKUPS = new WeakMap();
const SEEN_TAG_DEFS = new WeakMap();

function ___setTaglibLookup(file, lookup) {
  LOOKUPS.set(file, lookup);
  SEEN_TAG_DEFS.set(file, new Set());
}

function getTaglibLookup(file) {
  return LOOKUPS.get(file);
}

function getTagDefForTagName(file, tagName) {
  const tagDef = getTaglibLookup(file).getTag(tagName);

  if (tagDef) {
    const seen = SEEN_TAG_DEFS.get(file);

    if (!seen.has(tagDef)) {
      seen.add(tagName);
      const { filePath } = tagDef;
      const len = filePath.length;

      if (filePath[len - 14] === "m" && filePath.endsWith("marko-tag.json")) {
        file.metadata.marko.watchFiles.add(filePath);
      }
    }
  }
  return tagDef;
}
//# sourceMappingURL=taglib.js.map